org.apache.tapestry5.services

## Interface ComponentClassResolver

- All Known Implementing Classes:
    ComponentClassResolverImpl

      @UsesConfiguration(value=LibraryMapping.class)
      public interface ComponentClassResolver

  Resolves page names and component types to fully qualified class names. Pages and components may be provided by the application or inside a mapped package. Page names often appear inside URLs, and component types often appear in component templates (when specifying the type of an embedded component).

  The service is configured using a collection of `LibraryMapping`s. Each mapping maps a prefix, such as "core" to a root package name, such as "org.apache.tapestry5.corelib". The root package is expected to have sub-packages: "pages", "components", "mixins" and "base" ("base" is for base classes).

  The resolver performs a search of the classpath (via `ClassNameLocator`), to build up a set of case-insensitive maps from logical page name, component type, or mixin type to fully qualified class name.

  Certain ambiguities occur if mapped packages overlap, either in terms of the the prefixes or the package names. Keep things clearly separate to avoid lookup problems.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `canonicalizePageName(String pageName)` Returns the canonical form of a page name.
    `List<String>` | `getComponentNames()` Returns a list of all component names, in sorted order.
    `Map<String,ControlledPackageType>` | `getControlledPackageMapping()` Used to identify which packages are controlled packages (from which components are loaded).
    `Map<String,String>` | `getFolderToPackageMapping()` A mapping from virtual folder name to a package name (used for converting classpath `Asset`s to client URLs).
    `Collection<LibraryMapping>` | `getLibraryMappings()` Returns the library mappings.
    `String` | `getLibraryNameForClass(String className)` Given a class name of a component class, returns the library name (as defined by a contributed library name).
    `List<String>` | `getLibraryNames()` Returns the names of all libraries (as configured).
    `List<String>` | `getMixinNames()` Returns a list of all mixin names, in sorted order.
    `List<String>` | `getPageNames()` Returns a list of all page names, in sorted order.
    `boolean` | `isPage(String pageClassName)` Returns true if the class name is specifically a page class, and not a component, mixin or base class.
    `boolean` | `isPageName(String pageName)` For a particular path, determines if the path is a logical page name.
    `String` | `resolveComponentTypeToClassName(String componentType)` Converts a component type (a logical component name such as might be used inside a template or annotation) into a fully qualified class name.
    `String` | `resolveMixinTypeToClassName(String mixinType)` Converts a logical mixin type (as with component types) into a fully qualified class name.
    `String` | `resolvePageClassNameToPageName(String pageClassName)` Converts a fully qualified page class name into a page name (often, for inclusion as part of the URI).
    `String` | `resolvePageNameToClassName(String pageName)` Converts a logical page name (such as might be encoded into a URL) into a fully qualified class name.

- - ### Method Detail

    - #### resolvePageNameToClassName

          String resolvePageNameToClassName(String pageName)

      Converts a logical page name (such as might be encoded into a URL) into a fully qualified class name. The case of the page name is irrelevant.
      Parameters:
        `pageName` - page name
      Returns:
        fully qualified class name for the page
      Throws:
        `UnknownValueException` - if the name does not match a known page class

    - #### isPageName

          boolean isPageName(String pageName)

      For a particular path, determines if the path is a logical page name. The check is case insensitive.
      Parameters:
        `pageName` - potential logical page name
      Returns:
        true if the page name is valid

    - #### getPageNames

          List<String> getPageNames()

      Returns a list of all page names, in sorted order. These are the "canonical" page names.

    - #### getComponentNames

          @IncompatibleChange(release="5.4",
                              details="added method")
          List<String> getComponentNames()

      Returns a list of all component names, in sorted order. These are the "canonical" component names.
      Since:
        5.4

    - #### getMixinNames

          @IncompatibleChange(release="5.4",
                              details="added method")
          List<String> getMixinNames()

      Returns a list of all mixin names, in sorted order. These are the "canonical" mixin names.
      Since:
        5.4

    - #### resolvePageClassNameToPageName

          String resolvePageClassNameToPageName(String pageClassName)

      Converts a fully qualified page class name into a page name (often, for inclusion as part of the URI). This value may later be passed to `resolvePageNameToClassName(String)`.
      Parameters:
        `pageClassName` - fully qualified name of a page class
      Returns:
        equivalent logical page name
      Throws:
        `IllegalArgumentException` - if the name can not be resolved

    - #### canonicalizePageName

          String canonicalizePageName(String pageName)

      Returns the canonical form of a page name. The canonical form uses character case matching the underlying class name.
      Throws:
        `UnknownValueException` - if the page name does not match a logical page name

    - #### resolveComponentTypeToClassName

          String resolveComponentTypeToClassName(String componentType)

      Converts a component type (a logical component name such as might be used inside a template or annotation) into a fully qualified class name. Case is ignored in resolving the name.
      Parameters:
        `componentType` - a logical component type
      Returns:
        fully qualified class name
      Throws:
        `UnknownValueException` - if the component type can not be resolved

    - #### resolveMixinTypeToClassName

          String resolveMixinTypeToClassName(String mixinType)

      Converts a logical mixin type (as with component types) into a fully qualified class name. Case is ignored when resolving the name.
      Parameters:
        `mixinType` - a logical mixin type
      Returns:
        fully qualified class name
      Throws:
        `UnknownValueException` - if the mixin type can not be resolved

    - #### getFolderToPackageMapping

          Map<String,String> getFolderToPackageMapping()

      A mapping from virtual folder name to a package name (used for converting classpath `Asset`s to client URLs). This is derived from the contributed `LibraryMapping`s.

      It is allowed to contribute multiple root packages as a single folder name. In this case, the best common package name is used. For example, if both `com.example.main` and `com.example.extras` is mapped to folder "example", then the package mapping for "example" will be `com.example`.
      Since:
        5.2.0
      See Also:
        `ClasspathAssetAliasManager`

    - #### getLibraryNames

          List<String> getLibraryNames()

      Returns the names of all libraries (as configured). This does not include the application itself (which is a library with the virtual path of empty string).
      Returns:
        sorted names of libraries
      Since:
        5.4

    - #### getControlledPackageMapping

          Map<String,ControlledPackageType> getControlledPackageMapping()

      Used to identify which packages are controlled packages (from which components are loaded). Future expansion may allow for additional packages which are live reloaded but not components (or perhaps are transformed, but not as components).
      Returns:
        a mapping from package name to `ControlledPackageType`.
      Since:
        5.3

    - #### isPage

          boolean isPage(String pageClassName)

      Returns true if the class name is specifically a page class, and not a component, mixin or base class.
      Parameters:
        `pageClassName` -
      Returns:
        true if a page class
      Since:
        5.3

    - #### getLibraryNameForClass

          String getLibraryNameForClass(String className)

      Given a class name of a component class, returns the library name (as defined by a contributed library name).
      Parameters:
        `className` -
      Returns:
        library name
      Throws:
        `IllegalArgumentException` - if the class can't be matched to a contributed root package

    - #### getLibraryMappings

          @IncompatibleChange(release="5.4",
                              details="Added method")
          Collection<LibraryMapping> getLibraryMappings()

      Returns the library mappings.
      Returns:

${project.version} - Copyright © 2003-2014 The Apache Software Foundation.